// The contents of this file are subject to the Mozilla Public License Version 1.1
// (the "License"); you may not use this file except in compliance with the License.
// You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
// 
// Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
// WARRANTY OF ANY KIND, either express or implied. See the License for the specific
// language governing rights and limitations under the License.
// 
// The Original Code is the Venice Web Communities System.
// 
// The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
// for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
// Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
// 
// Contributor(s): 

importPackage(java.util);
importPackage(Packages.com.silverwrist.venice.core);
importPackage(Packages.com.silverwrist.venice.except);
importPackage(Packages.com.silverwrist.venice.ui);
importPackage(Packages.com.silverwrist.venice.ui.helpers);
importPackage(Packages.com.silverwrist.venice.ui.view);

rinput = bsf.lookupBean("request");

rc = null;
try
{ // generate the list of sideboxes we have
  in_list = rinput.user.getSideBoxList();
  ids = new HashSet(in_list.size());
  it = in_list.iterator();
  while (it.hasNext())
  { // add the IDs of all the sideboxes to the set
    descr = vlib.castSideBoxDescriptor(it.next());
    ids.add(descr.sideBoxID);

  } // end for

  all_list = rinput.engine.getMasterSideBoxList();
  out_list = null;
  if (all_list.size()>in_list.size())
  { // allocate an ArrayList to hold the sideboxes
    out_list = new ArrayList(all_list.size()-in_list.size());
    it = all_list.iterator();
    while (it.hasNext())
    { // get all sideboxes not on the "in" list and put them on the "out" list
      descr = vlib.castSideBoxDescriptor(it.next());
      if (!(ids.contains(descr.sideBoxID)))
        out_list.add(descr);

    } // end while

  } // end if
  else  // nothing in the "out list"
    out_list = Collections.EMPTY_LIST;

  // save off the two lists as request parameters
  rinput.setRequestAttribute("sideboxes.included",in_list);
  rinput.setRequestAttribute("sideboxes.excluded",out_list);

  // create a new JSPView for this
  rc = new JSPView("Your Front Page Configuration","user/sidebox.jsp");
  rc.menuSelector = Content.MENU_SELECTOR_TOP;

} // end try
catch (e)
{ // we got some sort of exception here
  etype = vlib.exceptionType(e) + "";
  if (etype.match("DataException"))
    rc = new ErrorBox("Database Error","Error getting sidebox list: " + e.message(),"top.js.vs");
  else
    rc = e;

} // end catch

vlib.output(rc);  // all done!
